---
type: api
title: Count search results
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v8/operation/operation-count
resource: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v8/operation/operation-count
products:
  - Elasticsearch
---

# Count search results


## Paths

- `POST` (also `GET`) `/{index}/_count`
- `POST` (also `GET`) `/_count`

#### Path parameters

- `index` (union string | string[]) — optional, leave it out to use `/_count`
  A comma-separated list of data streams, indices, and aliases to search.
It supports wildcards (`*`).
To search all data streams and indices, omit this parameter or use `*` or `_all`.

## Description

Get the number of documents matching a query.

The query can be provided either by using a simple query string as a parameter, or by defining Query DSL within the request body.
The query is optional. When no query is provided, the API uses `match_all` to count all the documents.

The count API supports multi-target syntax. You can run a single count API search across multiple data streams and indices.

The operation is broadcast across all shards.
For each shard ID group, a replica is chosen and the search is run against it.
This means that replicas increase the scalability of the count.

## Required authorization

- Index privileges: `read`

## Authentication

- Api key: `Authorization: <value>`
  Elasticsearch APIs support key-based authentication.
  You must create an API key and use the encoded value in the request header.
  For example:
  
  
  ```
  curl -X GET "${ES_URL}/_cat/indices?v=true" \
    -H "Authorization: ApiKey ${API_KEY}"
  ```
  
  To get API keys, use the `/_security/api_key` APIs.
- Basic: `Authorization: Basic <credentials>`
- Bearer: `Authorization: Bearer <token>`
  Elasticsearch APIs support the use of bearer tokens in the `Authorization` HTTP header to authenticate with the API.
  For examples, refer to [Token-based authentication services](https://www.elastic.co/guide/en/elasticsearch/reference/current/token-authentication-services.html)

## Query string parameters

- `allow_no_indices` (boolean · default: true) — optional
  If `false`, the request returns an error if any wildcard expression, index alias, or `_all` value targets only missing or closed indices.
This behavior applies even if the request targets other open indices.
For example, a request targeting `foo*,bar*` returns an error if an index starts with `foo` but no index starts with `bar`.
- `analyzer` (string) — optional
  The analyzer to use for the query string.
This parameter can be used only when the `q` query string parameter is specified.
- `analyze_wildcard` (boolean · default: false) — optional
  If `true`, wildcard and prefix queries are analyzed.
This parameter can be used only when the `q` query string parameter is specified.
- `default_operator` (enum · default: or) — optional
  The default operator for query string query: `and` or `or`.
This parameter can be used only when the `q` query string parameter is specified.
  Values: `and`, `AND`, `or`, `OR`
- `df` (string) — optional
  The field to use as a default when no field prefix is given in the query string.
This parameter can be used only when the `q` query string parameter is specified.
- `expand_wildcards` (string · default: open) — optional
  The type of index that wildcard patterns can match.
If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams.
It supports comma-separated values, such as `open,hidden`.

Supported values include:
  - `all`: Match any data stream or index, including hidden ones.
  - `open`: Match open, non-hidden indices. Also matches any non-hidden data stream.
  - `closed`: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  - `hidden`: Match hidden data streams and hidden indices. Must be combined with `open`, `closed`, or `both`.
  - `none`: Wildcard expressions are not accepted.
  Values: `all`, `open`, `closed`, `hidden`, `none`
- `ignore_throttled` (boolean · default: true) — optional — deprecated
  If `true`, concrete, expanded, or aliased indices are ignored when frozen.
- `ignore_unavailable` (boolean · default: false) — optional
  If `false`, the request returns an error if it targets a missing or closed index.
- `lenient` (boolean · default: false) — optional
  If `true`, format-based query failures (such as providing text to a numeric field) in the query string will be ignored.
This parameter can be used only when the `q` query string parameter is specified.
- `min_score` (number) — optional
  The minimum `_score` value that documents must have to be included in the result.
- `preference` (string) — optional
  The node or shard the operation should be performed on.
By default, it is random.
- `routing` (string) — optional
  A custom value used to route operations to a specific shard.
- `terminate_after` (number) — optional
  The maximum number of documents to collect for each shard.
If a query reaches this limit, Elasticsearch terminates the query early.
Elasticsearch collects documents before sorting.

IMPORTANT: Use with caution.
Elasticsearch applies this parameter to each shard handling the request.
When possible, let Elasticsearch perform early termination automatically.
Avoid specifying this parameter for requests that target data streams with backing indices across multiple data tiers.
- `q` (string) — optional
  The query in Lucene query string syntax. This parameter cannot be used with a request body.

## Request body

`application/json`

- `query` ({} Query) — optional
  Defines the search query using Query DSL. A request body query cannot be used
with the `q` query string parameter.
  See [Query](https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v8/types/_types-query_dsl-querycontainer)

## Response

`application/json`

- `count` (number)
- `_shards` (object)
  - `failed` (number)
    The number of shards the operation or search attempted to run on but failed.
  - `successful` (number)
    The number of shards the operation or search succeeded on.
  - `total` (number)
    The number of shards the operation or search will run on overall.
  - `failures` (object[])
    - `index` (string)
    - `node` (string)
    - `reason` (object)
      - `type` (string)
        The type of error
      - `reason` (union string) — nullable
        A human-readable explanation of the error, in English.
        One of: `string`
      - `stack_trace` (string)
        The server stack trace. Present only if the `error_trace=true` parameter was sent with the request.
      - `caused_by` (object) — recursive
        Same fields as `reason` in `failures`
      - `root_cause` (object[]) — recursive
        Same fields as `reason` in `failures`
      - `suppressed` (object[]) — recursive
        Same fields as `reason` in `failures`
    - `shard` (number)
    - `status` (string)
    - `primary` (boolean)
  - `skipped` (number)
## Code examples

#### Console

```console
POST /my-index-000001/_count
{
  "query" : {
    "term" : { "user.id" : "kimchy" }
  }
}
```

#### JavaScript

```javascript
const response = await client.count({
  index: "my-index-000001",
  query: {
    term: {
      "user.id": "kimchy",
    },
  },
});
```

#### Python

```python
resp = client.count(
    index="my-index-000001",
    query={
        "term": {
            "user.id": "kimchy"
        }
    },
)
```

#### curl

```curl
curl -X POST "$ELASTICSEARCH_URL/my-index-000001/_count" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "query": {
      "term": {
        "user.id": "kimchy"
      }
    }
  }'
```

#### Java

```java
client.count(c -> c
    .index("my-index-000001")
    .query(q -> q
        .term(t -> t
            .field("user.id")
            .value(FieldValue.of("kimchy"))
        )
    )
);
```

#### C#

```c#
var response = await client
    .CountAsync(d1 => d1
        .Indices(new[] { "my-index-000001" })
        .Query(d2 => d2
            .Term(d3 => d3
                .Field(x => x.User.Id)
                .Value("kimchy")
            )
        )
    );
```

#### PHP

```php
$resp = $client->count([
    "index" => "my-index-000001",
    "body" => [
        "query" => [
            "term" => [
                "user.id" => "kimchy",
            ],
        ],
    ],
]);
```

#### Ruby

```ruby
response = client.count(
  index: "my-index-000001",
  body: {
    "query": {
      "term": {
        "user.id": "kimchy"
      }
    }
  }
)
```

## Response examples

#### Count response example1

A successful response from `GET /my-index-000001/_count?q=user:kimchy`.

```json
{
  "count": 1,
  "_shards": {
    "total": 1,
    "successful": 1,
    "skipped": 0,
    "failed": 0
  }
}
```

